function [f,g,H] = Rosenbrock_optim(x)
% for optimization
% x: 2 x 1 vector,
% g: 2 x 1
% H: 2 x 2
% f: 1 x 1

f = 100*(x(2) - x(1).^2).^2 + (1 - x(1)).^2;
if (nargout > 1)
    g = [400*x(1)*(x(1)^2 - x(2)) + 2*(x(1)-1);     200*(x(2)-x(1)^2)];
    if (nargout > 2)
        H = [1200*x(1)^2 - 400*x(2) + 2,  -400*x(1);  -400*x(1),  200];
    end
end
return
%==========